package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLIDtoPWAffMap_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLIDtoPWAffMap extends JNIObject  {
	
	/* @generated */
	protected ISLIDtoPWAffMap(long ptr) {
		/*** PROTECTED REGION ID(ISLIDtoPWAffMap_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLIDtoPWAffMap build(long ptr) {
		return new ISLIDtoPWAffMap(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLIDtoPWAffMap_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_id_to_pw_aff_alloc 
	 * 
	 * @generated
	**/
	 public static ISLIDtoPWAffMap alloc(ISLContext ctx, int min_size) { 
		/*** PROTECTED REGION ID(static_isl_id_to_pw_aff_alloc) DISABLED START ***/
		ISLIDtoPWAffMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIDtoPWAffMap.build(ISLNative.isl_id_to_pw_aff_alloc(getNativePtr(ctx), min_size));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_pw_aff_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLIDtoPWAffMap id2pwa, int format) { 
		/*** PROTECTED REGION ID(static_isl_id_to_pw_aff_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_id_to_pw_aff_to_string(getNativePtr(id2pwa), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_id_to_pw_aff_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_id_to_pw_aff_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_id_to_pw_aff_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_pw_aff_copy 
	 * 
	 * @generated
	**/
	public ISLIDtoPWAffMap copy() {
		/*** PROTECTED REGION ID(isl_id_to_pw_aff_copy) DISABLED START ***/
		ISLIDtoPWAffMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIDtoPWAffMap.build(ISLNative.isl_id_to_pw_aff_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_pw_aff_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_id_to_pw_aff_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_id_to_pw_aff_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_pw_aff_has 
	 * 
	 * @generated
	**/
	public boolean containsKey(ISLIdentifier key) {
		/*** PROTECTED REGION ID(isl_id_to_pw_aff_has) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_id_to_pw_aff_has(getNativePtr(this), getNativePtr(key)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_pw_aff_get 
	 * 
	 * @take key
	 * @generated
	**/
	public ISLPWAff get(ISLIdentifier key) {
		/*** PROTECTED REGION ID(isl_id_to_pw_aff_get) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(key);
			try {
				res = ISLPWAff.build(ISLNative.isl_id_to_pw_aff_get(getNativePtr(this), getNativePtr(key)));
			} finally {
				taken(key);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_pw_aff_set 
	 * 
	 * @take this key val
	 * @generated
	**/
	public ISLIDtoPWAffMap put(ISLIdentifier key, ISLPWAff val) {
		/*** PROTECTED REGION ID(isl_id_to_pw_aff_set) DISABLED START ***/
		ISLIDtoPWAffMap res;
		
		synchronized(LOCK) {
			checkParameters(this, key, val);
			try {
				res = ISLIDtoPWAffMap.build(ISLNative.isl_id_to_pw_aff_set(getNativePtr(this), getNativePtr(key), getNativePtr(val)));
			} finally {
				taken(this);
				taken(key);
				taken(val);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_pw_aff_drop 
	 * 
	 * @take this key
	 * @generated
	**/
	public ISLIDtoPWAffMap remove(ISLIdentifier key) {
		/*** PROTECTED REGION ID(isl_id_to_pw_aff_drop) DISABLED START ***/
		ISLIDtoPWAffMap res;
		
		synchronized(LOCK) {
			checkParameters(this, key);
			try {
				res = ISLIDtoPWAffMap.build(ISLNative.isl_id_to_pw_aff_drop(getNativePtr(this), getNativePtr(key)));
			} finally {
				taken(this);
				taken(key);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLIDtoPWAffMap_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
